import java.io.*;
import java.util.*;

public class C {
	
	public class Person implements Comparable<Person> {
		int number;
		long t;
		long a;
		
		public Person(int number, long t, long a) {
			this.number = number;
			this.t = t;
			this.a = a;
		}

		@Override
		public int compareTo(Person o) {
			if (t > o.t) {
				return 1;
			} else if (t < o.t) {
				return -1;
			}
			return number - o.number;
		}
	}
	
    public void solve() throws IOException {
    	int n = nextInt();
    	int m = nextInt();
    	long[] ans = new long[n];
    	Queue<Person> queue = new ArrayDeque<>();
    	TreeSet<Person> next = new TreeSet<>();
    	for (int i = 0; i < ans.length; i++) {
			Person person = new Person(i, nextLong(), nextLong() - 1);
			queue.add(person);
			next.add(person);
		}
    	TreeMap<Long, Queue<Person>> map = new TreeMap<>();
    	long time = 0;
    	while (!next.isEmpty()) {
			Person ne = next.pollFirst();
			Long a = ne.a;
			time = Math.max(ne.t, time) + a;
			while (!queue.isEmpty() && queue.peek().t <= time + a) {
				Person p = queue.poll();
				if (map.containsKey(p.a)) {
					map.get(p.a).add(p);
				} else {
					Queue<Person> q = new ArrayDeque<>();
					q.add(p);
					map.put(p.a, q);
				}
			}
			while (a != null) {
				Queue<Person> q = map.get(a);
				while (!q.isEmpty() && q.peek().t <= time + ne.a - a) {
					Person p = q.poll();
					ans[p.number] = time + ne.a;
					next.remove(p);
				}
				if (q.isEmpty()) {
					map.remove(a);
				}
				a = map.lowerKey(a);
			}
			time += ne.a;
		}
    	for (int i = 0; i < ans.length; i++) {
			out.println(ans[i]);
		}
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }

}
