import java.io.*;
import java.util.*;

public class C {
	
	public class Person implements Comparable<Person> {
		int number;
		long t;
		long a;
		
		public Person(int number, long t, long a) {
			this.number = number;
			this.t = t;
			this.a = a;
		}

		@Override
		public int compareTo(Person o) {
			if (t > o.t) {
				return 1;
			} else if (t < o.t) {
				return -1;
			}
			return number - o.number;
		}
	}
	
	public class Queue {
		int l = 0;
		Person[] p;
		int r = 0;
		
		public Queue(int len) {
			p = new Person[len];
		}
		
		public void add(Person person) {
			p[r] = person;
			r++;
		}
		
		public boolean isEmpty() {
			return l == r;
		}
		
		public Person peek() {
			return p[l];
		}
		
		public Person poll() {
			l++;
			return p[l - 1];
		}
	}
	
    public void solve() throws IOException {
    	int n = nextInt();
    	int m = nextInt();
    	long[] ans = new long[n];
    	Person[] queue = new Person[n];
    	int qi = 0;
    	TreeSet<Person> next = new TreeSet<>();
    	HashMap<Long, Integer> num = new HashMap<>();
    	TreeSet<Long> etages = new TreeSet<>();
    	for (int i = 0; i < ans.length; i++) {
			Person person = new Person(i, nextLong(), nextLong() - 1);
			queue[i] = person;
			next.add(person);
			long a = person.a;
			etages.add(a);
			if (num.containsKey(a)) {
				num.put(a, num.get(a) + 1);
			} else {
				num.put(a, 1);
			}
		}
    	long[] etage = new long[etages.size()];
    	int it = 0;
    	for (long i : etages) {
			etage[it] = i;
			it++;
		}
    	HashMap<Long, Integer> numa = new HashMap<>();
    	for (int i = 0; i < etage.length; i++) {
			numa.put(etage[i], i);
		}
    	Queue[] queues = new Queue[etage.length];
//    	HashMap<Long, Queue> queues = new HashMap<>();
    	for (long l : numa.keySet()) {
			queues[numa.get(l)] = new Queue(num.get(l));
		}
    	TreeSet<Long> map = new TreeSet<>();
//    	TreeMap<Long, Queue> map = new TreeMap<>();
    	long time = 0;
    	while (!next.isEmpty()) {
			Person ne = next.pollFirst();
			Long a = ne.a;
			time = Math.max(ne.t, time) + a;
			while (qi != n && queue[qi].t <= time + a) {
				Person p = queue[qi];
				qi++;
				queues[numa.get(p.a)].add(p);
				if (!map.contains(p.a)) {
					map.add(p.a);
				}
			}
			while (a != null) {
				Queue q = queues[numa.get(a)];
				while (!q.isEmpty() && q.peek().t <= time + ne.a - a) {
					Person p = q.poll();
					ans[p.number] = time + ne.a;
					next.remove(p);
				}
				if (q.isEmpty()) {
					map.remove(a);
				}
				a = map.lower(a);
			}
			time += ne.a;
		}
    	for (int i = 0; i < ans.length; i++) {
			out.println(ans[i]);
		}
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }

}
