import java.io.*;
import java.util.*;

public class D {
	
	public class Point implements Comparable<Point> {
		int x;
		int c;
		
		public Point(int x, int c) {
			this.x = x;
			this.c = c;
		}

		@Override
		public int compareTo(Point arg0) {
			// TODO Auto-generated method stub
			return x - arg0.x;
		}
		
		
	}
	
	public class Vertex {
		int l;
		int r;
		Vertex left;
		Vertex right;
		HashMap<Integer, Integer> map = new HashMap<>();
		int color;
		
		public Vertex(Vertex left, Vertex right, int l, int r) {
			this.left = left;
			this.right = right;
			this.l = l;
			this.r = r;
			HashMap<Integer, Integer> m1 = left.map;
			HashMap<Integer, Integer> m2 = right.map;
			for (int i : m1.keySet()) {
				if (m2.containsKey(i)) {
					map.put(i, m1.get(i) + m2.get(i));
				} else {
					map.put(i, m1.get(i));
				}
			}
			for (int i : m2.keySet()) {
				if (!m1.containsKey(i)) {
					map.put(i, m2.get(i));
				}
			}
			int max = 0;
			for (int i : map.keySet()) {
				if (map.get(i) > max) {
					max = map.get(i);
					color = i;
				}
			}
		}
		
		public Vertex(int l, int r, int c) {
			this.l = l;
			this.r = r;
			left = null;
			right = null;
			color = c;
			map.put(c, r - l + 1);
		}
	}
	
	public Vertex build(int l, int r) {
		if (line[last + 1].x > r) {
			Vertex v = new Vertex(l, r, line[last].c);
			if (line[last + 1].x == r + 1) {
				last++;
			}
			return v;
		}
		int m = (l + r) / 2;
		return new Vertex(build(l, m), build(m + 1, r), l, r);
	}
	
	public void out(Vertex v) {
		System.out.println(v + " " + v.l + " " + v.r + " " + v.left + " " + v.right + " " + v.color);
		for (int i : v.map.keySet()) {
			System.out.println(i + " " + v.map.get(i));
		}
		System.out.println();
		if (v.left != null) {
			out(v.left);
			out(v.right);
		}
	}
	
	public void get(Vertex v, int c) {
		if (!v.map.containsKey(c) || v.map.get(c) != v.map.get(v.color)) {
			ans++;
			c = v.color;
		}
		if (v.left == null) {
			return;
		}
		get(v.left, c);
		get(v.right, c);
	}
	
	int k;
	Point[] line;
	int last = 0;
	Vertex root;
	int ans = 0;
	
    public void solve() throws IOException {
    	k = nextInt();
    	int n = nextInt();
    	int m = nextInt();
    	int x = 0;
    	line = new Point[n + 1];
    	for (int i = 0; i < n; i++) {
			int c = nextInt();
			line[i] = new Point(x, nextInt());
			x += c;
		}
    	line[n] = new Point(x, -1);
    	root = build(0, (1 << k) - 1);
//    	out(root);
    	get(root, -1);
    	System.out.println(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new D().run();
    }

}
